/* The MIT License
 *
 * Copyright (c) 2010 OTClient, https://github.com/edubart/otclient
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */


#ifndef SCRIPTABLE_H
#define SCRIPTABLE_H

#include <prerequisites.h>

class Scriptable : public boost::enable_shared_from_this<Scriptable>
{
public:
    Scriptable() : m_luaTableRef(-1) { }
    virtual ~Scriptable() { releaseLuaTableRef(); }

    //TODO: global destroy
    virtual const char *getScriptableName() const { return NULL; }

    int getLuaTableRef();
    void releaseLuaTableRef();
    void callLuaTableField(const std::string& field, int numArgs = 0);

private:
    int m_luaTableRef;
};

typedef boost::shared_ptr<Scriptable> ScriptablePtr;

#endif
