/* The MIT License
 *
 * Copyright (c) 2010 OTClient, https://github.com/edubart/otclient
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */


#ifndef UIWINDOW_H
#define UIWINDOW_H

#include <prerequisites.h>
#include <ui/uicontainer.h>

class UIWindow : public UIContainer
{
public:
    UIWindow() :
        UIContainer(UI::Window),
        m_moving(false) { }

    void onInputEvent(const InputEvent& event);

    void setTitle(const std::string& title) { m_title = title; }
    std::string getTitle() const { return m_title; }

    virtual const char *getScriptableName() const { return "UIWindow"; }

    virtual bool isFocusable() const { return true; }

private:
    std::string m_title;
    bool m_moving;
    Point m_movingReference;
};

typedef boost::shared_ptr<UIWindow> UIWindowPtr;

#endif // UIWINDOW_H
